//redFrik.  some old&ugly java/max code ported to sc 071201
// - released under gnu gpl license

RedConstruct {
	var	<>bounds, <>variant, <>mapping, <>cols, <>rows, <>movementX, <>movementY, <>stepX, <>stepY,
		<>i, <>x= 10, <>y= 10, <>dx= 1, <>dy= 1;
	*new {|bounds, variant, mapping, cols, rows, movementX= 0.95, movementY= 0.95, stepX= 1, stepY= 1|
		^super.new.init(bounds, variant, mapping, cols, rows, movementX, movementY, stepX, stepY);
	}
	init {|argBounds, argVariant, argMapping, argCols, argRows, argMovementX= 0.95, argMovementY= 0.95, argStepX= 1, argStepY= 1|
		bounds= argBounds.value??{bounds??{Rect(0, 0, 320, 240)}};
		variant= argVariant.value??{variant??{6.rand+1}};
		mapping= argMapping.value??{mapping??{16.rand+1}};
		cols= argCols.value??{cols??{12.rand+1}};
		rows= argRows.value??{rows??{7.rand+1}};
		movementX= argMovementX.value??{movementX};
		movementY= argMovementY.value??{movementY};
		stepX= argStepX.value??{stepX};
		stepY= argStepY.value??{stepY};
		this.randomDirectionXY;
		i= 0;
	}
	next {|n= 1|
		var res= [];
		n.do{
			res= res++this.prDrawFO;
			i= i+1;
			
			x= x+(dx*stepX);
			if(x<1, {								//if left border
				x= x.max(0);
				dx= 2.rand;
			}, {
				if(x>(bounds.width-1/cols), {		//if right border
					x= x.min(bounds.width-1/cols);
					dx= 0-2.rand;
				});
			});
			
			y= y+(dy*stepY);
			if(y<1, {								//if top border
				y= y.max(0);
				dy= 2.rand;
			}, {
				if(y>(bounds.height-1/rows), {		//if bottom border
					y= y.min(bounds.height-1/rows);
					dy= 0-2.rand;
				});
			});
			
			switch(variant,
				1, {
					if(1.0.rand>=movementX, {this.randomDirectionX});
					if(1.0.rand>=movementY, {this.randomDirectionY});
				},
				2, {
					this.randomDirectionXY;
				},
				3, {
					if(1.0.rand>=movementX, {
						if(dx==0 and:{x>=1}, {
							dx= -1;
						}, {
							dx= 0;
						});
					});
					if(1.0.rand>=movementY, {
						if(dy==0 and:{y>=1}, {
							dy= -1;
						}, {
							dy= 0;
						});
					});
				},
				4, {
					if(1.0.rand>=movementX, {
						if(dx==0 and:{x>=1}, {
							dx= -1;
						}, {
							dx= 0;
						});
					});
					if(1.0.rand>=movementY, {
						if(dy==0 and:{y<=(bounds.height-1/rows)}, {
							dy= 1;
						}, {
							dy= 0;
						});
					});
				},
				5, {
					if(1.0.rand>=movementX, {
						if(dx==0 and:{x<=(bounds.width-1/cols)}, {
							dx= 1;
						}, {
							dx= 0;
						});
					});
					if(1.0.rand>=movementY, {
						if(dy==0 and:{y>=1}, {
							dy= -1;
						}, {
							dy= 0;
						});
					});
				},
				6, {
					if(1.0.rand>=movementX, {
						if(dx==0 and:{x<=(bounds.width-1/cols)}, {
							dx= 1;
						}, {
							dx= 0;
						});
					});
					if(1.0.rand>=movementY, {
						if(dy==0 and:{y<=(bounds.height-1/rows)}, {
							dy= 1;
						}, {
							dy= 0;
						});
					});
				}
			);
		};
		^res
	}
	
	//--private
	prDrawFO {
		var points= [];
		cols.do{|i|
			rows.do{|j|
				var iCol= (bounds.width-1/cols*i).round;
				var jRow= (bounds.height-1/rows*j).round;
				
				switch(mapping,
					1, {				//no flip
						points= points.add(Point(x+iCol, y+jRow));
					},
					2, {				//flip all x
						points= points.add(Point(this.mirrorX(x)+iCol, y+jRow));
					},
					3, {				//flip all y
						points= points.add(Point(x+iCol, this.mirrorY(y)+jRow));
					},
					4, {				//flip all xy
						points= points.add(Point(this.mirrorX(x)+iCol, this.mirrorY(y)+jRow));
					},
					5, {				//flip odd col x
						if(i%2==1, {
							points= points.add(Point(this.mirrorX(x)+iCol, y+jRow));
						}, {
							points= points.add(Point(x+iCol, y+jRow));
						});
					},
					6, {				//flip odd col y
						if(i%2==1, {
							points= points.add(Point(x+iCol, this.mirrorY(y)+jRow));
						}, {
							points= points.add(Point(x+iCol, y+jRow));
						});
					},
					7, {				//flip odd col xy
						if(i%2==1, {
							points= points.add(Point(this.mirrorX(x)+iCol, this.mirrorY(y)+jRow));
						}, {
							points= points.add(Point(x+iCol, y+jRow));
						});
					},
					8, {				//flip odd row x
						if(j%2==1, {
							points= points.add(Point(this.mirrorX(x)+iCol, y+jRow));
						}, {
							points= points.add(Point(x+iCol, y+jRow));
						});
					},
					9, {				//flip odd row y
						if(j%2==1, {
							points= points.add(Point(x+iCol, this.mirrorY(y)+jRow));
						}, {
							points= points.add(Point(x+iCol, y+jRow));
						});
					},
					10, {			//flip odd row xy
						if(j%2==1, {
							points= points.add(Point(this.mirrorX(x)+iCol, this.mirrorY(y)+jRow));
						}, {
							points= points.add(Point(x+iCol, y+jRow));
						});
					},
					11, {			//flip odd col & even row x, flip even col & odd row x
						if(i%2==1 and:{j%2==0}, {
							points= points.add(Point(this.mirrorX(x)+iCol, y+jRow));
						}, {
							if(i%2==0 and:{j%2==1}, {
								points= points.add(Point(this.mirrorX(x)+iCol, y+jRow));
							}, {
								points= points.add(Point(x+iCol, y+jRow));
							});
						});
					},
					12, {			//flip odd col & even row y, flip even col & odd row y
						if(i%2==1 and:{j%2==0}, {
							points= points.add(Point(x+iCol, this.mirrorY(y)+jRow));
						}, {
							if(i%2==0 and:{j%2==1}, {
								points= points.add(Point(x+iCol, this.mirrorY(y)+jRow));
							}, {
								points= points.add(Point(x+iCol, y+jRow));
							});
						});
					},
					13, {			//flip odd col & even row xy, flip even col & odd row xy
						if(i%2==1 and:{j%2==0}, {
							points= points.add(Point(this.mirrorX(x)+iCol, this.mirrorY(y)+jRow));
						}, {
							if(i%2==0 and:{j%2==1}, {
								points= points.add(Point(this.mirrorX(x)+iCol, this.mirrorY(y)+jRow));
							}, {
								points= points.add(Point(x+iCol, y+jRow));
							});
						});
					},
					14, {			//flip even col & even row x, flip odd col & odd row x
						if(i%2==0 and:{j%2==0}, {
							points= points.add(Point(this.mirrorX(x)+iCol, y+jRow));
						}, {
							if(i%2==1 and:{j%2==1}, {
								points= points.add(Point(this.mirrorX(x)+iCol, y+jRow));
							}, {
								points= points.add(Point(x+iCol, y+jRow));
							});
						});
					},
					15, {			//flip even col & even row y, flip odd col & odd row y
						if(i%2==0 and:{j%2==0}, {
							points= points.add(Point(x+iCol, this.mirrorY(y)+jRow));
						}, {
							if(i%2==1 and:{j%2==1}, {
								points= points.add(Point(x+iCol, this.mirrorY(y)+jRow));
							}, {
								points= points.add(Point(x+iCol, y+jRow));
							});
						});
					},
					16, {			//flip even col & even row xy, flip odd col & odd row xy
						if(i%2==0 and:{j%2==0}, {
							points= points.add(Point(this.mirrorX(x)+iCol, this.mirrorY(y)+jRow));
						}, {
							if(i%2==1 and:{j%2==1}, {
								points= points.add(Point(this.mirrorX(x)+iCol, this.mirrorY(y)+jRow));
							}, {
								points= points.add(Point(x+iCol, y+jRow));
							});
						});
					}
				);
			};
		};
		^points;
	}
	randomDirectionXY {
		while({dx==0 and:{dy==0}}, {				//make sure both directions not zero
			dx= 2.rand2;
			dy= 2.rand2;
		});
	}
	randomDirectionX {
		dx= 2.rand2;
	}
	randomDirectionY {
		dy= 2.rand2;
	}
	mirrorX {|x|
		^(bounds.width-1/cols-x).round;
	}
	mirrorY {|y|
		^(bounds.height-1/rows-y).round;
	}
}